<template lang="pug">
	section#disco(
		:class="[{arrastrando}]",
		@dragenter="dragenter")

		barraLateral

		//-header
			hgroup
				h1 Proyecto 1
			nav
				.ruta
					a(href="#", title="title") Mis Archivos
					a(href="#", title="title") Proyectos
					a(href="#", title="title") Cliente 1
			.operaciones
				button( type="button" ).eliminar: vector(src="~@img/ico-borrar.svg?inline")
				button( type="button" ).favorito: vector(src="~@img/ico-favorito.svg?inline")
				button( type="button" ).configurar: vector(src="~@img/ico-ajustes.svg?inline")
				button( type="button" ).crear: vector(src="~@img/ico-agregar.svg?inline")
				button( type="button" ).subir: vector(src="~@img/ico-subir.svg?inline")
			.columnas
				.columna: h2 Archivo
				.columna: h2 Usuario
				.columna: h2 Acciones


		//-article.mensajes
			.mensaje.ok Copiado Exitoso
			.mensaje.error No se puede eliminar la carpeta
			.mensaje.info No tienes permisos suficientes

		//-section.listado
		section.contenido
			//-SelectorArbol
			router-view
			//-transition( name="fade", mode="out-in")

			//input.archivos(type="file", @change="fileChanged", ref="archivos", "multiple")
			//-p {{contenido}}
			//-Listado

		//-section.detalle
			tarjeta(titulo="Carpeta", :expandir="false", v-if="carpeta.id")
				vector(slot="icono", src="@img/ico-carpeta.svg?inline")
				dl.propiedades
					dt Propietario:
					dd {{ carpeta.propietario }}
					dt Compartido:
					dd {{ carpeta.compartido }}
					dt Archivos:
					dd {{ carpeta.archivos }}
					dt Carpetas:
					dd {{ carpeta.carpetas }}

				h4 Descripción:
				p {{ carpeta.descripción }}

			tarjeta(titulo="Archivo", estado="activo", :expandir="true", v-if="archivo.id")
				.cartel
					IconoFichero(:ext="archivo.ext")
					h3 {{ archivo.nombre }}
					p {{archivo.descripcion}}
				.acciones
					button( type="button" ).eliminar: vector( src="~@img/ico-borrar.svg?inline")
					button( type="button" ).favorito: vector( src="@img/ico-favorito.svg?inline")
					button( type="button" ).descargar: vector( src="@img/ico-descargar.svg?inline")
					button( type="button" ).ver: vector( src="@img/ico-ver.svg?inline")
					button( type="button" ).compartir: vector( src="@img/ico-compartir.svg?inline")

				dl.propiedades
					dt Propietario:
					dd {{ archivo.propietario }}
					dt Último acceso:
					dd {{ archivo.ultimo_acceso }}
					dt Compartido:
					dd {{ archivo.compartido }}

			tarjeta.comentarios(titulo="Comentarios", estado="activo", v-if="archivo.id")
				.listaComentarios
					ItemComentario( v-for="item in archivo.comentarios", :comentario="item", :key="item.id" )
				.comentar
					textarea#Comentario(name="comentario", cols="30", rows="10", placeholder="Comentar...")
					figure: img(src="@img/man-user.svg", alt="Mobil")
					h3 Juan Campos
					button( type="button" ) Comentar

		//-section.subidas( v-if="subida.length" )
			Subida( v-for="operacion in subida", :key="operacion.id", :idu="operacion.id", :archivo="operacion.archivo",
				@terminada="subidaTerminada")
			//-Subida
			//-Subida

		modal.comparteArchivo(
			name="compartirArchivo",
			:max-width="720",
			:max-height="140",
			:adaptive="true",
			width="80%",
		)
			button.cerrar(
				type="button",
				@click="$modal.hide('compartirArchivo')" ) &times;
			.contenido
				h3 Enlace del archivo
				.campo
					input(type = "text", v-model="archivoEnlace", "readonly",@focus="$event.target.select()", @click.prevent="$event.target.select()")


		article.cobertura(
		@drop.stop.prevent="drop",
		@dragover.prevent="dragOver",
		@dragenter="dragenter",
		@dragend="dragend",
		@dragleave="dragleave" )
			h3 Suelta tus archivos aquí


</template>


<script>
	import BarraLateral from "@/components/BarraLateral";
	import Listado from "@/components/Listado";
	import Tarjeta from "@/components/Tarjeta";
	import IconoFichero from "@/components/IconoFichero";
	import ItemComentario from "@/components/ItemComentario";
	import Subida from "@/components/Subida";
	import SelectorArbol from "@/components/SelectorArbol";
	import { enlace as obtenerEnlace } from "@/api/archivos";
	import { mapState, mapActions, mapMutations } from "vuex";


	console.info("conectado", navigator.userAgent );

	export default {
		name: "Disco",
		components: {
			BarraLateral,
			Listado,
			Tarjeta,
			IconoFichero,
			ItemComentario,
			Subida,
			SelectorArbol
		},
		data() {
			return {
				arrastrando: false,
				archivoEnlace: "",
				subida: [],
			};
		},
		watch: {
			$route({ name, params }) {
				//console.log(name, params);
				switch (name) {
					case "carpeta":
					case "disco":
						this.seleccionarTaxonomia("carpeta");
						break;
					case "etiqueta":
						this.seleccionarTaxonomia("etiqueta");
						break;
					case "categoria":
						this.seleccionarTaxonomia("categoria");
						break;

					default:
						this.seleccionarTaxonomia("");
						break;
				}
			}
		},
		computed: {
			...mapState(["carpeta", "disco", "etiqueta", "categoria", "taxonomia"])
		},
		methods: {
			dragOver(evt) {
				//console.log(evt.dataTransfer.files);
				let efct;
				try {
					efct = evt.dataTransfer.effectAllowed;
				} catch (error) {}
				evt.dataTransfer.dropEffect =
					"move" === efct || "linkMove" === efct ? "move" : "copy";
			},
			drop(evt) {
				//console.log(evt.dataTransfer);
				//console.log(evt.dataTransfer.files);
				const yo = this;

				var reader = new FileReader();
				reader.onload = this.fileReaderLoad;
				// /*reader.onload = function( evt ){
				// 	var datos = reader.result;
				// 	console.log( evt );
				// 	//yo.contenido = datos;
				// 	//var output = document.getElementById('output');
				// 	//output.src = dataURL;
				// };*/
				//reader.readAsBinaryString(evt.dataTransfer.files[0]);

				for (let i = 0; i < evt.dataTransfer.files.length; i++) {
					var operacion = {
						id: uid(),
						archivo: evt.dataTransfer.files[i]
					};
					//this.subida.push(operacion);
					this.$root.$emit("archivo-agregar", operacion);

					//console.log( "R", element );
				}

				this.arrastrando = false;
			},
			fileReaderLoad(evt) {
				let fr = evt.currentTarget;
				//console.log( "R", fr.result);
			},
			dragenter() {
				console.log("dragenter");
				this.arrastrando = true;
			},
			dragend() {
				this.arrastrando = false;
				console.log("dragend");
			},
			dragleave() {
				//this.arrastrando = false;
				this.arrastrando = false;
				console.log("dragleave");
			},
			subidaTerminada(idu) {
				for (let i = 0; i < this.subida.length; i++) {
					//console.log(this.subida[i].id, idu);
					if (this.subida[i].id == idu) {
						this.subida.splice(i, 1);
						break;
						//console
					}
				}

				if (this.taxonomia == "carpeta") {
					this.obtenerArchivos({ id: this.carpeta.id });
				} else {
					this.obtenerArchivos({ id: this.categoria.id });
				}
				this.obtenerEtiquetas();
			},
			fileChanged(evt) {
				// console.debug(evt);
				// console.debug(evt.target);
				// console.debug(evt.target.files);
				// console.debug(evt.target.files.length);
				for (let i = 0; i < evt.target.files.length; i++) {
					var operacion = {
						id: uid(),
						archivo: evt.target.files[i]
					};
					this.subida.push(operacion);
				}
			},
			...mapActions([
				"obtenerArchivos",
				"obtenerCarpetas",
				"obtenerCarpeta",
				"obtenerEtiquetas"
			]),
			...mapMutations(["seleccionarTaxonomia"])
		},
		created() {
			console.log("created", this.$route);
			if (this.$route.name == "disco") {
				this.seleccionarTaxonomia("carpeta");
			} else {
				this.seleccionarTaxonomia(this.$route.name);
			}
			//this.obtenerCarpetas();
		},
		activated() {
			console.log("activated");
			//this.obtenerCarpeta({ id: this.carpeta.id });
		},
		mounted() {
			//this.seleccionarTaxonomia( "carpeta" );
			//console.log( "mounted", this.$name )
			//this.obtenerArchivos();
			//console.log( "mounted", this.disco.id );
			//this.obtenerCarpetas();
			//this.obtenerArchivos({ id: this.carpeta.id });
			//this.obtenerCarpeta({ id: this.carpeta.id });
			/*
			this.$root.$on("archivo-subir", () => {
				this.$refs.archivos.click();
			});
			*/

			this.$root.$on("archivo-compartir", id => {
				this.$modal.show("compartirArchivo");
				this.archivoEnlace = "";
				obtenerEnlace(id).then(rpta => (this.archivoEnlace = rpta.url));
			});

			//this.$modal.show("compartirArchivo");
		}
	};

	function uid() {
		const a = Math.random()
			.toString(36)
			.replace(/[^a-z]+/g, "")
			.substr(2);
		const b = Math.random()
			.toString(36)
			.substr(2);

		return a + b;
	}
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	#disco
		display grid
		/*
		grid-template-areas "lateral mensajes mensajes"
		"lateral encabezado encabezado"
		"lateral listado detalle"
		"lateral listado archivo"
		"lateral subidas subidas"
		"lateral visor visor"
		*/
		grid-template-areas "lateral mensajes mensajes" "lateral contenido contenido" "lateral subidas subidas" "lateral visor visor"
		grid-template-columns 25vw 5fr 2fr
		grid-template-rows repeat( 3, min-content ) 1fr min-content
		grid-gap 0 1rem
		padding 1rem
		background-color white

		.archivos
			position fixed
			top 0
			left 0
			z-index -1
			visibility hidden

	.barraLateral
		grid-area lateral
		margin-left -1rem
		margin-bottom -1rem

	.mensajes
		grid-area mensajes

		.mensaje
			font-size calcRem( 12 )
			padding .5em 1rem
			margin-bottom .2em
			border 1px solid gris
			box-sizing border-box
			color alpha( darken( gris, 50% ), 75% )
			background-color tint( gris, 50% )
			font-weight 300
			cursor pointer

			&::before
				content "mensaje:"
				text-transform uppercase
				font-weight bolder
				margin-right .2em

			&.ok
				background-color tint( green, 50% )
				border-color desaturate( green, 50% )

				&::before
					content "correcto:"

			&.error
				background-color tint( red, 50% )
				border-color desaturate( red, 50% )

				&::before
					content "error:"

			&.info
				background-color tint( cyan, 50% )
				border-color desaturate( cyan, 50% )

				&::before
					content "atención:"

	.listado
		grid-area listado
		background-color tint( azul, 90% )
		margin-bottom 1rem

		input
			// background-color aqua

		.arrastrando &
			/* input
			absolute top left
			width 50%
			height 50% */

	.contenido
		grid-area contenido
		margin-bottom 1rem

	.detalle
		grid-area detalle
		margin 0

		.tarjeta
			margin-bottom .5rem

			.cartel
				display grid
				grid-template-areas "icono nombre" "icono descripcion"
				grid-column-gap .5rem
				grid-template-columns 1fr 3fr
				margin-bottom .5rem

				h3
					margin-bottom .5em
					font-size calcRem( 14 )
					font-weight bolder
					color tint( azul, 30% )

				p
					margin 0
					font-size calcRem( 12 )

				.iconoFichero
					grid-area icono
					width 100%

			.contenido
				padding 1rem
				color gris
				background-color tint( azul, 80% )

			.propiedades
				display grid
				grid-template-columns auto 1fr
				grid-column-gap 1em
				grid-row-gap .5em
				align-items end
				font-size calcRem( 12 )
				font-weight 300

				dt
					flex 1 0 50%
					font-weight bolder
					color tint( azul, 50% )

				dd
					flex 1 1 auto

			h4
				color tint( azul, 50% )
				font-size calcRem( 12 )
				margin-bottom .5rem

			p
				font-size calcRem( 10 )
				line-height 1.2
				font-weight 300
				margin-bottom 1em

			&.comentarios
				>>> .contenido
					background-color #fff
					padding 0

			.listaComentarios
				padding .5rem

				.itemComentario
					margin-bottom .5rem

			.comentar
				display grid
				grid-template-areas "texto texto texto" "foto nombre boton"
				grid-template-columns min-content 1fr 1fr
				grid-template-rows min-content min-content
				grid-gap .2rem .5rem
				align-items center

				textarea
					grid-area texto
					font-size calcRem( 10 )
					font-weight 300
					padding 1em
					background-color #F2F2F2
					border 1px solid #E6E6E6
					width 100%
					height 6em
					display block
					resize vertical

				figure
					align-self start
					grid-area foto
					width 48px
					height 48px
					border-radius 48px
					box-sizing border-box
					border 2px solid blanco
					background-color tint( azul, 60% )
					overflow hidden
					margin-left 1rem

				h3
					grid-area nombre
					text-align left
					color darken( gris, 50% )
					font-weight 500
					font-size calcRem( 10 )

				button
					grid-area boton
					font-size calcRem( 10 )
					font-weight 500
					line-height 1
					color blanco
					background-color tint( azul, 30% )
					border none
					padding .6rem .8rem
					border-radius 2rem

		.acciones
			flex 0 0 200px
			display flex
			justify-content space-between
			margin-bottom .5rem

			button
				flex 0 0 32px
				border none
				width 32px
				height 32px
				border-radius 1rem
				display flex
				align-items center
				justify-content center
				padding 0
				margin 0 .1rem
				cursor pointer
				color tint( azul, 40% )
				background-color transparente

				&:hover
					background-color tint( azul, 90% )

				.vector
					height 20px

					svg
						display block

			.eliminar
				color tint( rojo, 40% )

	.subidas
		// grid-area subidas
		fixed bottom left right
		padding .5rem .5rem 0
		background-color tint( azul, 80% )
		box-sizing border-box
		max-height 100vh
		overflow auto

		.subida
			margin-bottom .5rem

	.cobertura
		absolute top left right bottom
		background alpha( azul, 50% )
		align-items center
		justify-content center
		display none

		.arrastrando &
			display flex

		h3
			font-weight 900
			font-size 3rem
			color alpha( tint( azul, 70% ), 70% )
			pointer-events none

	.comparteArchivo
		.cerrar
			absolute top right
			padding .2rem .4rem
			color tint( azul, 40% )
			background-color blanco
			font-size 1.5rem
			cursor pointer
			font-weight bold
			z-index 1

		.contenido
			margin 0
			padding 2rem
			width 100%
			max-width 100%
			box-sizing border-box

			h3
				font-weight bold
				font-size 1rem
				margin-bottom .4rem

			.campo
				display flex
				padding .5rem .8rem
				border 1px solid alpha( #CCC, 50% )
				border-radius .2rem

				// background-color tint( azul, 40% )
				input
					color grey
					flex 1 0 auto
					border none
					outline none
</style>
